VERSION 5.00
Begin VB.Form frmUTF8Test 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "UTF-8 Encoder/Decoder"
   ClientHeight    =   2445
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7605
   BeginProperty Font 
      Name            =   ""
      Size            =   10.5
      Charset         =   134
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2445
   ScaleWidth      =   7605
   StartUpPosition =   2  'Ļ
   Begin VB.CheckBox chkSample 
      Caption         =   ""
      Height          =   255
      Left            =   3240
      TabIndex        =   9
      Top             =   560
      Width           =   1575
   End
   Begin VB.CheckBox chkURL 
      Caption         =   "URL"
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   560
      Width           =   1575
   End
   Begin VB.CommandButton cmdEncode 
      Caption         =   ""
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   840
      Width           =   1575
   End
   Begin VB.CommandButton cmdDecode 
      Caption         =   ""
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   1575
   End
   Begin VB.TextBox txtDecoded 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   10.5
         Charset         =   134
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      Locked          =   -1  'True
      TabIndex        =   4
      Top             =   1320
      Width           =   5640
   End
   Begin VB.TextBox txtEncoded 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   10.5
         Charset         =   134
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   840
      Width           =   5640
   End
   Begin VB.TextBox txtContent 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   10.5
         Charset         =   134
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   5640
   End
   Begin VB.Frame Frame4 
      Height          =   855
      Left            =   6480
      TabIndex        =   1
      Top             =   4440
      Width           =   1335
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "˳(&X)"
      Height          =   495
      Left            =   6360
      TabIndex        =   0
      Top             =   1800
      Width           =   1095
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "(&T)"
      Height          =   210
      Index           =   0
      Left            =   120
      TabIndex        =   7
      ToolTipText     =   "Enter your Unicode characters here, they will be encoded using the specified codepage"
      Top             =   165
      Width           =   945
   End
End
Attribute VB_Name = "frmUTF8Test"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' You can use this source code as you please, all I ask is that you respect the author's
' *very few* copyright restrictions of the basInCodePage Module as that is not my work.

Option Explicit

Private u As New cUTF8



Private Sub chkSample_Click()
    txtContent.Text = "%E6%B5%8B%E8%AF%95"
End Sub

Private Sub chkURL_Click()
    cmdEncode.Enabled = chkURL.Value = vbUnchecked
    txtEncoded.Enabled = cmdEncode.Enabled
End Sub

Private Sub cmdEncode_Click()
    txtEncoded.Text = u.EncodeUTF8(txtContent.Text)
End Sub

Private Sub cmdDecode_Click()
    Dim s As String
    Dim o_bytConent() As Byte
    If chkURL.Value Then
        s = txtContent.Text
        u.DecodeURL s, o_bytConent
        s = StrConv(o_bytConent, vbUnicode)
    Else
        s = txtEncoded.Text
    End If
    
    txtDecoded.Text = u.DecodeUTF8(s)
End Sub

Private Sub Command5_Click()
    txtContent.Text = vbNullString
    txtEncoded.Text = vbNullString
    txtDecoded.Text = vbNullString
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    cmdExit_Click
End Sub
